-- LearningAid v1.00 by Jamash (Kil'jaeden-US)

LearningAid = {}

-- Copied from SpellBookFrame.lua
function LearningAid.UpdateButton(self)
  --if ( not SpellBookFrame.selectedSkillLine ) then
  --  SpellBookFrame.selectedSkillLine = 1;
  --end
  --local temp, texture, offset, numSpells = SpellBook_GetTabInfo(SpellBookFrame.selectedSkillLine);
  --SpellBookFrame.selectedSkillLineOffset = offset;

  local id = self:GetID();
  local name = self:GetName();
  local iconTexture = getglobal(name.."IconTexture");
  local spellString = getglobal(name.."SpellName");
  local subSpellString = getglobal(name.."SubSpellName");
  local cooldown = getglobal(name.."Cooldown");
  local autoCastableTexture = getglobal(name.."AutoCastable");

  --if ( (SpellBookFrame.bookType ~= BOOKTYPE_PET) and (not displayID or displayID > (offset + numSpells)) ) then
  --  self:Disable();
  --  iconTexture:Hide();
  --  spellString:Hide();
  --  subSpellString:Hide();
  --  cooldown:Hide();
  --  autoCastableTexture:Hide();
  --  SpellBook_ReleaseAutoCastShine(self.shine)
  --  self.shine = nil;
  --  self:SetChecked(0);
  --  getglobal(name.."NormalTexture"):SetVertexColor(1.0, 1.0, 1.0);
  --  return;
  --else
    self:Enable();
  --end
  local texture = GetSpellTexture(id, BOOKTYPE_SPELL);
  local highlightTexture = getglobal(name.."Highlight");
  local normalTexture = getglobal(name.."NormalTexture");
  -- If no spell, hide everything and return
  if ( not texture or (strlen(texture) == 0) ) then
    iconTexture:Hide();
    spellString:Hide();
    subSpellString:Hide();
    cooldown:Hide();
    autoCastableTexture:Hide();
    SpellBook_ReleaseAutoCastShine(self.shine)
    self.shine = nil;
    highlightTexture:SetTexture("Interface\\Buttons\\ButtonHilight-Square");
    self:SetChecked(0);
    normalTexture:SetVertexColor(1.0, 1.0, 1.0);
    return;
  end
  
  local start, duration, enable = GetSpellCooldown(id, BOOKTYPE_SPELL);
  CooldownFrame_SetTimer(cooldown, start, duration, enable);
  if ( enable == 1 ) then
    iconTexture:SetVertexColor(1.0, 1.0, 1.0);
  else
    iconTexture:SetVertexColor(0.4, 0.4, 0.4);
  end

  --local autoCastAllowed, autoCastEnabled = GetSpellAutocast(id, BOOKTYPE_SPELL);
  --if ( autoCastAllowed ) then
  --  autoCastableTexture:Show();
  --else
  --  autoCastableTexture:Hide();
  --end
  --if ( autoCastEnabled and not self.shine ) then
  --  self.shine = SpellBook_GetAutoCastShine();
  --  self.shine:Show();
  --  self.shine:SetParent(self);
  --  self.shine:SetPoint("CENTER", self, "CENTER");
  --  AutoCastShine_AutoCastStart(self.shine);
  --elseif ( not autoCastEnabled ) then
  --  SpellBook_ReleaseAutoCastShine(self.shine);
  --  self.shine = nil;
  --end

  local spellName, subSpellName = GetSpellName(id, BOOKTYPE_SPELL);
  --local isPassive = IsPassiveSpell(id, BOOKTYPE_SPELL);
  --if ( isPassive ) then
  --  normalTexture:SetVertexColor(0, 0, 0);
  --  highlightTexture:SetTexture("Interface\\Buttons\\UI-PassiveHighlight");
    --subSpellName = PASSIVE_PARENS;
  --  spellString:SetTextColor(PASSIVE_SPELL_FONT_COLOR.r, PASSIVE_SPELL_FONT_COLOR.g, PASSIVE_SPELL_FONT_COLOR.b);
  --else
  --  normalTexture:SetVertexColor(1.0, 1.0, 1.0);
  --  highlightTexture:SetTexture("Interface\\Buttons\\ButtonHilight-Square");
  --  spellString:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
    --self:SetAttribute("button1", "cast")
  --end
  
  -- Set Secure Action Button attribute
  self:SetAttribute("spell1", spellName)
  
  iconTexture:SetTexture(texture);
  spellString:SetText(spellName);
  subSpellString:SetText(subSpellName);
  if ( subSpellName ~= "" ) then
    spellString:SetPoint("LEFT", self, "RIGHT", 4, 4);
  else
    spellString:SetPoint("LEFT", self, "RIGHT", 4, 2);
  end

  iconTexture:Show();
  spellString:Show();
  subSpellString:Show();
  --SpellButton_UpdateSelection(self);
end

-- Copied from SpellBookFrame.lua
function LearningAid.SpellButton_OnDrag(self) 
  local id = self:GetID();
  if ( id > MAX_SPELLS or not getglobal(self:GetName().."IconTexture"):IsShown() ) then
    return;
  end
  self:SetChecked(0);
  PickupSpell(id, BOOKTYPE_SPELL);
end

-- Copied from SpellBookFrame.lua
function LearningAid.SpellButton_OnEnter(self)
	local id = self:GetID();
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
	if ( GameTooltip:SetSpell(id, BOOKTYPE_SPELL) ) then
		self.UpdateTooltip = LearningAid.SpellButton_OnEnter;
	else
		self.UpdateTooltip = nil;
	end
end

-- Copied from SpellBookFrame.lua
function LearningAid.SpellButton_OnClick(self, button) 
	local id = self:GetID();
	if ( id > MAX_SPELLS ) then
		return;
	end
--	if ( button ~= "LeftButton" and SpellBookFrame.bookType == BOOKTYPE_PET ) then
--		ToggleSpellAutocast(id, SpellBookFrame.bookType);
--	else
		CastSpell(id, BOOKTYPE_SPELL);
--		SpellButton_UpdateSelection(self);
--	end
end

function LearningAid.OnLoad(self)
  self:RegisterEvent("SPELLS_CHANGED")
  --self:RegisterEvent("LEARNED_SPELL_IN_TAB")
  self:RegisterEvent("PLAYER_LOGIN")
end

function LearningAid.OnEvent(self, event, ...)
  if event == "PLAYER_LOGIN" then
    LearningAid.UpdateSpellBook()
  elseif (event == "SPELLS_CHANGED" or event == "LEARNED_SPELL_IN_TAB") and LearningAid.SpellBookCache ~= nil then
    local updated = LearningAid.DiffSpellBook()
    if updated then
      LearningAid.UpdateSpellBook()
    else
      --DEFAULT_CHAT_FRAME:AddMessage("Event "..event.." fired without spell changes")
    end
  end
end

function LearningAid.UpdateSpellBook()
  LearningAid.SpellBookCache = {}
  local i = 1
  local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
  while spellName do
    LearningAid.SpellBookCache[i] = { name = spellName, rank = spellRank }
    i = i + 1
    spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
  end
end

function LearningAid.DiffSpellBook()
  local i = 1
  local offset = 0
  local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
  local cache = LearningAid.SpellBookCache
  local updated = false
  while spellName do
    if cache[i + offset] == nil or
       cache[i + offset].name ~= spellName or
       cache[i + offset].rank ~= spellRank then
      -- if spell removed
      if cache[i + offset + 1] ~= nil and
         cache[i + offset + 1].name == spellName and
         cache[i + offset + 1].rank == spellRank then
        --DEFAULT_CHAT_FRAME:AddMessage("Old spell removed: "..cache[i + offset].name.." ("..cache[i + offset].rank..") id "..(i + offset))
        LearningAid.ClearButtonID(LearningAid.Frame, i + offset)
        LearningAid.RemoveAbility(LearningAid.Frame, i + offset)
        offset = offset + 1
      elseif not IsPassiveSpell(i, BOOKTYPE_SPELL) then -- if spell added that isn't passive
        -- Display button with dragable spell icon
        --DEFAULT_CHAT_FRAME:AddMessage("New spell found: "..spellName.." ("..spellRank..")") -- Old spell: "..cache[i + offset].name.." ("..cache[i + offset].rank..")")
        LearningAid.AddAbility(LearningAid.Frame, i)
        LearningAid.AddButton(LearningAid.Frame, i)
        offset = offset - 1
      end
      -- remember to update cache
      updated = true
    end
    i = i + 1
    spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
  end
  -- if the last spell in the spellbook is removed
  if i == #cache and not updated then
    LearningAid.ClearButtonID(LearningAid.Frame, i)
    LearningAid.RemoveAbility(LearningAid.Frame, i)
    --DEFAULT_CHAT_FRAME:AddMessage("Last spell removed: "..cache[i].name.." ("..cache[i].rank..") id "..i)
    offset = offset + 1
    updated = true
    --LearningAid.Button:Hide()
  end
  return updated
end
function LearningAid.AddAbility(parent, id)
  local buttons = parent.Buttons
  for i = 1, parent.Visible do
    if buttons[i]:GetID() >= id then
      buttons[i]:SetID(buttons[i]:GetID() + 1)
      LearningAid.UpdateButton(buttons[i])
    end
  end
end
function LearningAid.RemoveAbility(parent, id)
  local buttons = parent.Buttons
  for i = 1, parent.Visible do
    if buttons[i]:GetID() > id then
      buttons[i]:SetID(buttons[i]:GetID() - 1)
      LearningAid.UpdateButton(buttons[i])
    end
  end
end
function LearningAid.CreateButton(parent)
  local count = #parent.Buttons
  local name = "SpellButton_LearningAid_"..(count + 1)
  local button = CreateFrame("CheckButton", name, parent, "LearningAidSpellButtonTemplate")
  local subSpellName = getglobal(name.."SubSpellName")
  subSpellName:SetTextColor(NORMAL_FONT_COLOR.r - 0.1, NORMAL_FONT_COLOR.g - 0.1, NORMAL_FONT_COLOR.b - 0.1)
  parent.Buttons[count + 1] = button
  button.Index = count + 1
  if count > 0 then
    -- position relative to button above
    button:SetPoint("TOP", parent.Buttons[count], "BOTTOM", 0, -LearningAid.ButtonSpacing)
  else
    -- position relative to header
    button:SetPoint("TOPLEFT", parent.TitleBar, "BOTTOMLEFT", 16, 0)
  end
  button:SetAttribute("type1", "spell")
  button:SetAttribute("type2", "hideButton")
  button.hideButton = function(self, button, down) LearningAid.ClearButtonIndex(LearningAid.Frame, self.Index) end

  return button
end

function LearningAid.SpellButton_OnHide(self)
  --DEFAULT_CHAT_FRAME:AddMessage("Hiding button "..self.Index)
  --LearningAid.ClearButtonIndex(LearningAid.Frame, self.Index)
end

function LearningAid.AddButton(frame, id)
  local buttons = frame.Buttons
  local button
  if frame.Visible == #buttons then
    button = LearningAid.CreateButton(frame)
    --DEFAULT_CHAT_FRAME:AddMessage("Adding button id "..id.." index "..button.Index)
  else
    button = buttons[frame.Visible + 1]
    --DEFAULT_CHAT_FRAME:AddMessage("Changing button index "..(frame.Visible + 1).." from id "..button:GetID().." to "..id)
    button:Show()
  end
  button:SetID(id)
  LearningAid.UpdateButton(button)
  LearningAid.SetVisible(frame, frame.Visible + 1)
  frame:Show()
  if id > 1 then
    local name, rank = GetSpellName(id, BOOKTYPE_SPELL)
    local prevName, prevRank = GetSpellName(id - 1, BOOKTYPE_SPELL)
    if name == prevName then
      LearningAid.ClearButtonID(frame, id - 1)
    end
  end
end

function LearningAid.ClearButtonID(frame, id)
  local buttons = frame.Buttons
  local i = 1
  while i <= frame.Visible do
    if buttons[i]:GetID() == id then
      --DEFAULT_CHAT_FRAME:AddMessage("Clearing button "..i.." with ID "..buttons[i]:GetID())
      LearningAid.ClearButtonIndex(frame, i)
    else
      --DEFAULT_CHAT_FRAME:AddMessage("Button "..i.." has id "..buttons[i]:GetID().." which does not match "..id)
      i = i + 1
    end
  end
end

-- I have buttons 1 2 3 (4 5)
-- I remove button 2
-- I want 1 3 (3 4 5)
-- before, Visible = 3
-- after, Visible = 2
function LearningAid.ClearButtonIndex(frame, index)
  local buttons = frame.Buttons
  for i = index, frame.Visible - 1 do
    buttons[i]:SetID(buttons[i + 1]:GetID())
    --if buttons[i]:IsShown() then
    LearningAid.UpdateButton(buttons[i])
    --end
  end
  buttons[frame.Visible]:Hide()
  LearningAid.SetVisible(frame, frame.Visible - 1)
  if frame.Visible == 0 then
    frame:Hide()
  end
end
function LearningAid.SetVisible(frame, visible)
  frame.Visible = visible
  local top, left = frame:GetTop(), frame:GetLeft()
  frame:SetHeight(LearningAid.TitleHeight + 10 + (LearningAid.ButtonSize + LearningAid.ButtonSpacing) * visible)
  frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", left, top)
end
function LearningAid.Hide(frame)
  for i = 1, frame.Visible do
    frame.Buttons[i]:Hide()
  end
  frame.Visible = 0
  frame:Hide()
end
function LearningAid.TestAdd(...)
  local t = {...}
  for i = 1, #t do 
    if not IsPassiveSpell(i, BOOKTYPE_SPELL) then
      LearningAid.AddButton(LearningAid.Frame, t[i])
    end
  end
  --LearningAid.AddButton(LearningAid.Frame, 2)
  --LearningAid.AddButton(LearningAid.Frame, 3)
  --LearningAid.AddButton(LearningAid.Frame, 4)
  --LearningAid.AddButton(LearningAid.Frame, 5)
end

function LearningAid.TestRemove()
  LearningAid.ClearButtonID(LearningAid.Frame, 4)
  LearningAid.ClearButtonID(LearningAid.Frame, 3)
  LearningAid.ClearButtonID(LearningAid.Frame, 2)
  LearningAid.ClearButtonID(LearningAid.Frame, 5)
  LearningAid.ClearButtonID(LearningAid.Frame, 1)
end

LearningAid.TitleHeight = 40
LearningAid.Width = 170
LearningAid.ButtonSpacing = 5
LearningAid.ButtonSize = 37
LearningAid.TitleText = "Learning Aid"

local Frame = CreateFrame("Frame", "LearningAid_Frame", UIParent)
LearningAid.Frame = Frame
Frame:SetPoint("TOPLEFT", UIParent, "CENTER", 200, 100)
Frame:SetWidth(LearningAid.Width)
Frame:SetHeight(LearningAid.TitleHeight)
Frame:SetMovable(true)
Frame:SetClampedToScreen(true)
Frame:SetScript("OnEvent", LearningAid.OnEvent)
Frame.Buttons = {}
Frame.Visible = 0
Frame:Hide()
local backdrop = { 
  bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
  edgeFile = "Interface/DialogFrame/UI-DialogBox-Gold-Border",
  tile = false, tileSize = 16, edgeSize = 16,
  insets = { left = 4, right = 4, top = 4, bottom = 4 }
}
Frame:SetBackdrop(backdrop)

local TitleBar = CreateFrame("Frame", "LearningAid_Frame_TitleBar", Frame)
Frame.TitleBar = TitleBar
TitleBar:SetPoint("TOPLEFT")
TitleBar:SetPoint("TOPRIGHT")
TitleBar:SetHeight(LearningAid.TitleHeight)
TitleBar:RegisterForDrag("LeftButton")
TitleBar:EnableMouse()
TitleBar:SetScript("OnDragStart", function (self, button) self:GetParent():StartMoving() end)
TitleBar:SetScript("OnDragStop", function (self) self:GetParent():StopMovingOrSizing() end)
TitleBar:SetScript("OnMouseUp", function (self, button) if button == "RightButton" then LearningAid.Hide(self:GetParent()) end end)
TitleBar.Text = TitleBar:CreateFontString("LearningAid_Frame_Title_Text", "OVERLAY", "GameFontNormalLarge")
TitleBar.Text:SetText(LearningAid.TitleText)
TitleBar.Text:SetPoint("CENTER", TitleBar, "CENTER", 0, 0)

LearningAid.OnLoad(Frame)

